;============================
;xplore 1k by rich bayliss
;============================

objpos = $cf00
collision = $cf10

			
			!to "xplore.prg",cbm
			
			* = $1000-2
			!binary "sfx.prg"
			* = $2000 ;Position sprites here
			!binary "sprites.spr"
			* = $2800
			!binary "chars.chr.chr.chr"
		
			* = $3000
			sei
			
;Clear initialize the whole screen, create the score board and
;draw some lines for the game screen.
			lda #$0f
			sta $d418
			jsr $ff81
			lda #$00
			sta $d020
			sta $d021
			jsr $ff81
			lda #$02
			sta shield
			lda #<irq
			ldx #>irq
			sta $314
			stx $315
			lda #$7f
			sta $dc0d
			lda #$01
			sta $d01a
			lda #$ff
			jsr $1000
			
;Setup sound perameters for the game

		 
			

			cli	
			lda #$00
			sta $d020
			sta $d021
			lda #$18
			sta $d016
			lda #$1a
			sta $d018
			ldx #$00
addstatus:	lda stat,x
			sta $0400,x
			lda #$07
			sta $d800,x
			inx
			cpx #$28
			bne addstatus
			
restart	lda #$ff
			sta $d015
			sta $d01c
			lda #$00
			sta $d017
			sta $d01d
			sta $d01b
			lda #$0a
			ldx #$02
			sta $d022
			stx $d023
			lda #$06
			ldx #$03
			ldy #$0e
			sta $d027
			sta $d028
			sta $d029
			sta $d02a
			sta $d02b
			sta $d02c
			sta $d02d
			sta $d02e
			stx $d026
			sty $d025
			lda #$00
			sta firelock
			lda player_ship
			sta $07f8
			lda player_bullet
			sta $07f9
			
			ldx #$00
tospr:		lda enemy_planet
			sta $07fa,x
			inx
			cpx #$06
			bne tospr

;Create the forcefield for which the player must blast through to be able to
;complete a level.

			ldx #$00
barrier:	lda #$a0
			sta $0400+(7*40),x
			lda #$0f
			sta $d800+(7*40),x
			inx
			cpx #$f0
			bne barrier
			
;Set up the default starting positions for the actual game sprites

			ldx #$00
setpos:	lda startpos,x
			sta objpos+$00,x
			inx
			cpx #$10
			bne setpos
				
			
		
main:		lda #$00
			sta sync
			lda sync
syncwait:	cmp sync
			beq syncwait
			jsr expandxpos
			jsr forceship
			jsr joyread
			jsr bulletmove
			jsr bgcol
			jsr moveblocks
			jsr moveplanets
			jsr sprcol
			jsr randomizer
			jsr bgrcollision
			jmp main
irq:		inc $d019
			lda #$00
			sta $d012
			lda #$01
			sta sync
			jsr $1003
			jmp $ea7e
			
			
;Increase the no of pixels sprites can move, so that they can go through
;the whole screen instead of using 256 pixels.

expandxpos:
			ldx #$00
expand		lda objpos+$01,x
			sta $d001,x
			lda objpos+$00,x
			asl
			ror $d010
			sta $d000,x
			inx
			inx
			cpx #$10
			bne expand
			rts
			
;Force ship to go up the screen until it reaches a limit, therefore the
;level is complete.

forceship:	inc counter
			lda counter
timer: 	cmp #$20
			beq moveup
			rts
moveup		lda #$00
			sta counter
			ldx objpos+$01
			
			dex
			cpx #$40
			bcs notdone
			inc $0427
			lda timer+1
			sec
			sbc #$02
			sta timer+1
			lda $0427
			cmp #$39
			beq resetlv
			jmp restart
resetlv	lda #$31
			sta $0427
			lda #$20
			sta timer+1
			rts
			
notdone:	stx objpos+$01
			rts
			
;Read left + right + fire joystick controls
;so player can move or shoot

joyread		lda $dc00
				lsr
				lsr
				lsr
				bcs right
				ldx objpos+0
				dex
				cpx #$06
				bcs stopleft
				ldx #$06
stopleft		stx objpos+0
right:			lsr
				bcs fire
				ldx objpos+0
				inx
				cpx #$a2
				bcc stopright
				ldx #$a2
stopright:		stx objpos+0
fire			lsr
				bcs nofire
				lda firelock
				cmp #$01
				beq nofire
				ldx objpos+0
				stx objpos+2
				ldx objpos+1
				stx objpos+3
				lda #$ff
				jsr $1000
				lda #$01
				jsr $1000
				lda #$01
				sta firelock
nofire			rts

;Bullet movement

bulletmove:	lda firelock
				cmp #$01
				beq movebullet
				rts
movebullet:	
				
				ldx objpos+3
				dex
				dex
				dex
				dex
				dex
				dex
				dex
				dex
				cpx #$3c
				bcs contmove
				ldx #$00
				stx objpos+$03
				stx objpos+$02
				lda #$00
				sta firelock
contmove:		stx objpos+3
				
				rts
				
;Player bullet to background collision routine
				
bgcol	 lda objpos+3
		sec
		sbc #$32
		lsr
		lsr
		lsr
		tay
		lda scrlo,y
		sta $70
		lda scrhi,y
		sta $71
		lda objpos+2
		sec
		sbc #$06
		lsr
		lsr
		tay
		ldx #2
		sty _selfmod+1
		
_l1	lda ($70),y
		cmp #32
		bne _hit
		;iny
		;lda ($70),y
		;cmp #32
		;bne _hit
		;iny
		;lda ($70),y
		;cmp #32
		;bne _hit
		
		
_selfmod ldy #$00
		lda $70
		clc
		adc #$28
		sta $70
		bcc _l2
		inc $71
		
_l2	dex
		bne _l1
		
		
		
not_hit	 rts

_hit	;lda _selfmod+1
		;cmp #65
		;bne notthat
		
		lda #$20
		sta ($70),y
		lda #$00
		sta objpos+2
		sta objpos+3
		lda #$00
		sta firelock
		jsr score
		rts
		
		
;Our score routine
score 	inc $040a
		ldx #5
scloop	lda $0406,x
		cmp #$3a
		bne scok
		lda #$30
		sta $0406,x
		inc $0405,x
scok	dex
		bne scloop
		rts
		
;Rotate those blocks across the screen for the player		
		
moveblocks:	jsr scrollleft
				jsr scrollright
				rts
				
scrollleft:	
				lda xpause1
				sec
xspeed1:		sbc #$01
				and #$07
				sta xpause1
				bcs finish1
				ldx #$00
wrapblocks1	lda $0400+(7*40)+1,x
				sta $0400+(7*40)+0,x
				lda $0400+(9*40)+1,x
				sta $0400+(9*40)+0,x
				lda $0400+(11*40)+1,x
				sta $0400+(11*40)+0,x
				lda $0400+(13*40)+1,x
				sta $0400+(13*40)+0,x
				inx
				cpx #$28
				bne wrapblocks1
				lda $0400+(7*40)
				sta $0400+(7*40)+$27
				lda $0400+(9*40)
				sta $0400+(9*40)+$27
				lda $0400+(11*40)
				sta $0400+(11*40)+$27
				lda $0400+(13*40)
				sta $0400+(13*40)+$27
finish1		rts

scrollright	lda $0400+(8*40)
				sta temp5
				lda $0400+(10*40)
				sta temp6
				lda $0400+(12*40)
				sta temp7
				lda xpause2
				clc
				adc #$01
				and #7
				sta xpause2
				lda xpause2
				cmp #7
				bne finish2
				
				ldx #$27
wrap2			lda $0400+(8*40)-1,x
				sta $0400+(8*40)+0,x
				lda $0400+(10*40)-1,x
				sta $0400+(10*40)+0,x
				lda $0400+(12*40)-1,x
				sta $0400+(12*40)+0,x
				dex
				bne wrap2
				lda $0400+(8*40)+$27
				sta $0400+(8*40)
				lda $0400+(10*40)+$27
				sta $0400+(10*40)
				lda $0400+(12*40)+$27
				sta $0400+(12*40)
finish2		rts
				
;Drop those falling planets down the screen

moveplanets:	ldx #$00
moveloop:		lda objpos+$05,x
				clc
				adc speed,x
				cmp #$fa
				bcc pok
				lda #$00
				sta objpos+$05,x
				lda randx
				sta objpos+$04,x
				rts
pok				sta objpos+$05,x
				inx
				inx
				cpx #$0c
				bne moveloop
				rts

;Enemy sprites to player collision

sprcol:		lda objpos+$00
				sec
				sbc #$06
				sta collision
				clc
				adc #$0c
				sta collision+1
				lda objpos+$01
				sec
				sbc #$0c
				sta collision+2
				clc
				adc #$18
				sta collision+3
				ldx #$00
checkenemy:	lda objpos+$04,x
				cmp collision
				bcc snothit
				cmp collision+1
				bcs snothit
				lda objpos+$05,x
				cmp collision+2
				bcc snothit
				cmp collision+3
				bcs snothit
				jsr deadbit
snothit		inx
				inx
				cpx #$0c
				bne checkenemy
				rts

randomizer 	ldx randcount
				lda randtable,x
				sta randx
				inx
				cpx #24
				beq randreset
				inc randcount
				rts
randreset		ldx #$00
				stx randcount
				rts
				
bgrcollision: lda $d01f
				lsr
				bcc alive
				dec shield
				lda shield
				cmp #$00
				bne alive
				lda #$02
				sta shield
				jsr deadbit
alive			rts

deadbit		lda #$ff
				jsr $1000
				lda #$00
				jsr $1000
				lda #$00
				sta $02
				sta $03
delaycol		inc $d027
				inc $02
				lda $02
				cmp #$cc
				bne delaycol
				lda #$00
				sta $02
				inc $03
				lda $03
				cmp #$cc
				bne delaycol
			
				
				dec $0418
				lda $0418
				cmp #$30
				beq theend
				jmp restart
theend			ldx #$00
showend		lda #$01
				sta $d8a0,x
				lda gameovermess,x
				sta $04a0,x
				inx
				cpx #$28
				bne showend
				lda #$00
				sta $d015
				lda #$ff
				jsr $1000
				lda #$02
				jsr $1000
		
waitforspace	lda $dc01
				cmp #$ef
				bne waitforspace
				jmp $3000

				
				
				

				
				

				

				
				



				

				
				

				
randcount			!byte $00
randx				!byte $00				
randtable			!byte $08,$80,$98,$a0,$28,$18
					!byte $48,$78,$38,$58,$50,$70
					!byte $10,$48,$40,$30,$90,$40
					!byte $78,$90,$50,$78,$38,$28
		
speed				!byte $01,$00,$02,$00,$03,$00,$02,$00,$01,$00,$02,$00
				
xtmp  				!byte $00
killerchars:      !byte $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1a,$1b,$1c,$1d,$1e,$1f
				    !byte $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$30,$31,$32,$33,$34,$35
					!byte $36,$37,$38,$39,$3a,$3b,$3c,$3d,$3e,$3f,$40,$41,$42,$43,$44,$45
					!byte $46,$47,$48,$49,$4a,$4b,$4c,$4d,$4e,$4f,$50,$51,$52,$53,$54,$55
					!byte $56,$57,$58,$59,$5a,$5b,$5c,$5d,$5e,$5f,$60,$61,$62,$63,$64,$65
					!byte $66,$67,$68,$69,$6a,$6b,$6c,$6d,$6e,$6f,$70,$71,$72,$73,$74,$75
					!byte $76,$77,$78,$79,$7a,$7b,$7c,$7d,$7e,$7f,$80,$81,$82,$83,$84,$85
					!byte $86,$87,$88,$90,$8a,$8b,$8c,$8d,$8e,$8f,$90,$91,$92,$93,$94,$95
					!byte $96,$97,$98,$99,$9a,$9b,$9c,$9d,$9e,$9f,$a0,$a1,$a2,$a3,$a4,$a5
					!byte $a6,$a7,$a8,$a9,$aa,$ab,$ac,$ad,$ae,$af,$b0,$b1,$b2,$b3,$b4,$b5
					!byte $b6,$b7,$b8,$b9,$ba,$bb,$bc,$bd,$be,$bf,$c0,$c1,$c2,$c3,$c4,$c5
					!byte $c6,$c7,$c8,$c9,$ca,$cb,$cc,$cd,$ce,$cf,$d0,$d1,$d2,$d3,$d4,$d5
					!byte $d6,$d7,$d8,$d9,$da,$db,$dc,$dd,$de,$df,$e0,$e1,$e2,$e3,$e4,$e5
					!byte $e6,$e7,$e8,$e9,$ea,$eb,$ec,$ed,$ee,$ef,$f0,$f1,$f2,$f3,$f4,$f5
					!byte $f6,$f7,$f8,$f9,$fa,$fb,$fc,$fd,$fe,$ff,$ff,$ff,$ff,$ff,$ff,$ff

scrhi 			!byte $04,$04,$04,$04,$04,$04,$04,$05,$05,$05,$05,$05,$05,$06,$06,$06,$06,$06,$06,$06,$07,$07,$07,$07,$07,$07
scrlo 			!byte $00,$28,$50,$78,$a0,$c8,$f0,$18,$40,$68,$90,$b8,$e0,$08,$30,$58,$80,$a8,$d0,$f8,$20,$48,$70,$98,$c0,$e0
		
stat:			!scr "score:000000      lives:3        level:1"
gameovermess	!scr "       game over - hit spacebar         "




player_ship:	!byte $80
player_bullet: !byte $81
enemy_planet:	!byte $82
sync:			!byte $00
counter:		!byte $00
firelock:		!byte $00
startpos:		!byte $56,$e8 ;Player 1
				!byte $00,$00 ;Player bullet
				!byte $20,$10 ;Enemy1
				!byte $40,$80 ;Enemy2
				!byte $60,$c0 ;Enemy3
				!byte $80,$00 ;Enemy4
				!byte $a0,$c0 ;Enemy5
				!byte $c0,$80 ;Enemy6
temp1			!byte 0,0
temp2			!byte 0,0
temp3			!byte 0,0
temp4			!byte 0,0
temp5			!byte 0,0
temp6			!byte 0,0
temp7			!byte 0,0
shield			!byte 2

xpause1		!byte 0,0
xpause2		!byte 0,0